//     C:\W\DELPHI\GRAPH\EMat\    !!!!
unit Common;  {   }
interface
type
  TErrProc= Procedure( s: string );
var
  wsize   : integer;  //    
  ErrProc : TErrProc; //  
  tmp     : integer;

Function  N2Str ( x: extended; size: integer ): string;
Function  I2Str ( x: longint;  size: integer ): string;

//  ,   
Function  I20Str ( x: longint; size: integer ): string;
Procedure hOpen ( fn: string; var f: text );
Procedure hWrite( fn, mess: string );
Procedure hClear( fn: string );
function  extended2byte( x: extended ): integer;
function  power_( x: extended; k: integer ):extended;
function  dfd2psnr( d: extended ): extended;
//   s    ,    delim
function  firstWord( var s: string; delim:string ):string;
function  Hypot3( x,y,z: extended ): extended;
Function  hTime: string;

implementation
uses math, strUtils, sysUtils;
{--------------------------------------------------------------------------}
Function  N2Str ( x: extended; size: integer ): string;
var
  s : string[32];
begin
  if x=0 then begin Str( 0:size, s ); N2Str:=s; Exit; end;
  if x<0 then begin N2Str := '-'+N2Str( -x, size-1 ); Exit; end;
  //   x>0
  if (x>0.0001)and(x<   10) then begin Str( x:size:size-2, s ); N2Str:=s; Exit; end;
  if (x>=   10)and(x<  100) then begin Str( x:size:size-3, s ); N2Str:=s; Exit; end;
  if (x>=  100)and(x< 1000) then begin Str( x:size:size-4, s ); N2Str:=s; Exit; end;
  if (x>= 1000)and(x<10000) then begin Str( x:size:size-5, s ); N2Str:=s; Exit; end;

  Str( x:(size+1), s ); N2Str:=copy(s, 2, length(s)-1);
end;
{--------------------------------------------------------------------------}
Function  I2Str ( x: longint; size: integer ): string;
var
  s : string;
begin
  //Str( x:size, s );
  //I2Str:=s;
  Str( x, s );
  s := StringOfChar(' ', size-length(s))+s;
  I2Str:=s;
end;
{--------------------------------------------------------------------------}
{  ,   }
Function  I20Str ( x: longint; size: integer ): string;
var
  s : string[16];
begin
  Str( x, s );
  s := StringOfChar('0', size-length(s))+s;
  I20Str:=s;
end;
{--------------------------------------------------------------------------}
Procedure hOpen ( fn: string; var f: text );
begin
  {$I-}
  Assign( f, fn );    Append( f );
  {$I+}
  if IOResult <> 0 then Rewrite( f );
end;
{--------------------------------------------------------------------------}
Procedure hWrite( fn, mess: string );
var f: text;
begin
  hOpen( fn, f );
  WriteLn( f, mess );
  Close( f );
end;
{--------------------------------------------------------------------------}
Procedure hClear( fn: string );
var f: text;
begin
  Assign( f, fn );  Rewrite( f );  Close( f );
end;
{--------------------------------------------------------------------------}
Procedure ErrProc0( s: string );
begin
  WriteLn( 'hError:', s );
  //ReadLn;
  Halt(1);
end;

// -------------------------------------------------------------
function extended2byte( x: extended ): integer;
begin
    if x<  0 then begin extended2byte:=0;   exit; end;
    if x>255 then begin extended2byte:=255; exit; end;
    extended2byte:=round(x);
end;

//--------------------------------------------------------------------------
function  power_( x: extended; k: integer ):extended;
var i: integer;
	r: extended;
begin
	if k=0 then begin power_:=1; exit; end;
	if k=1 then begin power_:=x; exit; end;
	if k=2 then begin power_:=x*x; exit; end;
	if k=3 then begin power_:=x*x*x; exit; end;
	if k=4 then begin r:=x*x; power_:=r*r; exit; end;
	if k=5 then begin r:=x*x; power_:=r*r*x; exit; end;
	if k=6 then begin r:=x*x; power_:=r*r*r; exit; end;
    r:=x;
    for i:=2 to k do r:=r*x;
    power_ := r;
end;
//----------------------------------------------------------------------
function dfd2psnr( d: extended ): extended; begin dfd2psnr :=20*log10(255/d);end;
//--------------------------------------------------------------------------
//   s    ,    delim
function  firstWord( var s: string; delim:string ):string;
var l, p0, p1: integer;
	word: string;
begin
	l:=length(s);
	p0:=1;
    while (p0<=l) and (pos(s[p0], delim)>0) do inc(p0);
    //  s[p0] -     
    p1:=p0;
    while (p1<=l) and (pos(s[p1], delim)=0) do
    	inc(p1);
    word := copy(s, p0, p1-p0);
    delete( s, 1, p1);
    firstWord := word;
end;
//--------------------------------------------------------------------------
function  Hypot3( x,y,z: extended ): extended;
begin
	Hypot3 := sqrt(x*x + y*y + z*z);
end;
//--------------------------------------------------------------------------
Function  hTime: string;
begin
  hTime := 'Time: '+ DateToStr(Date)+' '+TimeToStr(Time);
end;
//--------------------------------------------------------------------------
begin
  ErrProc := ErrProc0;   {    }
  wsize   := 12; 
end.

